Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 711076 (CVE-2020-5247) - <www-servers/puma-{3.12.3,4.3.2}: HTTP Response Splitting (CVE-2020-5247)
Summary: <www-servers/puma-{3.12.3,4.3.2}: HTTP Response Splitting (CVE-2020-5247)
Status: RESOLVED FIXED
Alias: CVE-2020-5247
Product: Gentoo Security
Classification: Unclassified
Component: Vulnerabilities (show other bugs)
Hardware: All Linux
: Normal trivial (vote)
Assignee: Gentoo Security
URL: https://github.com/puma/puma/security...
Whiteboard: B4 [noglsa cve]
Keywords:
Depends on:
Blocks:
 
Reported: 2020-02-29 06:00 UTC by Hans de Graaff
Modified: 2020-03-15 02:07 UTC (History)
1 user (show)

See Also:
Package list:
www-servers/puma-3.12.4
Runtime testing required: ---
stable-bot: sanity-check+


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Hans de Graaff gentoo-dev 2020-02-29 06:00:32 UTC
In Puma (RubyGem) before 4.3.2 and 3.12.2, if an application using Puma allows untrusted input in a response header, an attacker can use newline characters (i.e. `CR`, `LF` or`/r`, `/n`) to end the header and inject malicious content, such as additional headers or an entirely new response body. This vulnerability is known as HTTP Response Splitting. While not an attack in itself, response splitting is a vector for several other attacks, such as cross-site scripting (XSS). This is related to CVE-2019-16254, which fixed this vulnerability for the WEBrick Ruby web server. This has been fixed in versions 4.3.2 and 3.12.3 by checking all headers for line endings and rejecting headers with those characters.

Fixed in puma 3.12.3 and puma 4.3.2.
Comment 1 GLSAMaker/CVETool Bot gentoo-dev 2020-02-29 15:09:08 UTC
CVE-2020-5247 (https://nvd.nist.gov/vuln/detail/CVE-2020-5247):
  In Puma (RubyGem) before 4.3.2 and 3.12.2, if an application using Puma
  allows untrusted input in a response header, an attacker can use newline
  characters (i.e. `CR`, `LF` or`/r`, `/n`) to end the header and inject
  malicious content, such as additional headers or an entirely new response
  body. This vulnerability is known as HTTP Response Splitting. While not an
  attack in itself, response splitting is a vector for several other attacks,
  such as cross-site scripting (XSS). This is related to CVE-2019-16254, which
  fixed this vulnerability for the WEBrick Ruby web server. This has been
  fixed in versions 4.3.2 and 3.12.3 by checking all headers for line endings
  and rejecting headers with those characters.
Comment 2 Agostino Sarubbo gentoo-dev 2020-03-01 13:04:21 UTC
amd64 stable
Comment 3 Agostino Sarubbo gentoo-dev 2020-03-02 12:33:07 UTC
x86 stable.

Maintainer(s), please cleanup.
Security, please vote.
Comment 4 Hans de Graaff gentoo-dev 2020-03-05 07:59:57 UTC
Cleanup done.
Comment 5 Thomas Deutschmann gentoo-dev 2020-03-15 02:07:36 UTC
GLSA Vote: No!

Repository is clean, all done.